/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of FDpasser.xs. Do not edit this file, edit FDpasser.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "FDpasser.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"



#ifdef FDPASSER_BSD

#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/uio.h>

#if defined(__sun)
#undef SCM_RIGHTS
#endif




static int send_fd(int passer_fd, int fd_to_send) {
  struct msghdr msg;
#ifdef SCM_RIGHTS
  struct cmsghdr *cmsg;
  union {
    struct cmsghdr hdr;
    unsigned char buf[CMSG_SPACE(sizeof(int))];
  } cmsgbuf;
#endif
  struct iovec vec;
  char junkbuf[1];

  memset(&msg, 0, sizeof(msg));

  msg.msg_iov = &vec;
  msg.msg_iovlen = 1;
  vec.iov_base = (void*) &junkbuf;
  vec.iov_len = 1;
  junkbuf[0] = '\0';

#ifdef SCM_RIGHTS
  msg.msg_control = &cmsgbuf.buf;
  msg.msg_controllen = sizeof(cmsgbuf.buf);
  cmsg = CMSG_FIRSTHDR(&msg);
  cmsg->cmsg_len = CMSG_LEN(sizeof(int));
  cmsg->cmsg_level = SOL_SOCKET;
  cmsg->cmsg_type = SCM_RIGHTS;
  *(int *)CMSG_DATA(cmsg) = fd_to_send;
#else
  msg.msg_accrights = (void*) &fd_to_send;
  msg.msg_accrightslen = sizeof(fd_to_send);
#endif

  return sendmsg(passer_fd, &msg, 0);
}

static int recv_fd(int passer_fd) {
  struct msghdr msg;
#ifdef SCM_RIGHTS
  struct cmsghdr *cmsg;
  union {
    struct cmsghdr hdr;
    unsigned char buf[CMSG_SPACE(sizeof(int))];
  } cmsgbuf;
#endif
  struct iovec vec;
  char junkbuf[1];
  int rv;
  int recv_fd;

  memset(&msg, 0, sizeof(msg));

  vec.iov_base = junkbuf;
  vec.iov_len = 1;
  msg.msg_iov = &vec;
  msg.msg_iovlen = 1;

#ifdef SCM_RIGHTS

  msg.msg_control = &cmsgbuf.buf;
  msg.msg_controllen = sizeof(cmsgbuf.buf);

  rv = recvmsg(passer_fd, &msg, 0);

  if (rv < 0) return -1;

  if ((msg.msg_flags & MSG_TRUNC) || (msg.msg_flags & MSG_CTRUNC)) return -2;

  for (cmsg = CMSG_FIRSTHDR(&msg); cmsg != NULL; cmsg = CMSG_NXTHDR(&msg, cmsg)) {
    if (cmsg->cmsg_len == CMSG_LEN(sizeof(int)) &&
        cmsg->cmsg_level == SOL_SOCKET &&
        cmsg->cmsg_type == SCM_RIGHTS) {
      rv = *(int *)CMSG_DATA(cmsg);
    }
  }

#else

  msg.msg_accrights = (void*) &recv_fd;
  msg.msg_accrightslen = sizeof(recv_fd);

  rv = recvmsg(passer_fd, &msg, 0);

  if (rv > 0) {
    rv = recv_fd;
  }

#endif

  return rv;
}


static int fdpasser_mode() {
  return 1;
}


static int _fdpasser_server(char *path) {
  // Only used in SysV
  assert(0);
}

static int _fdpasser_accept(char fd) {
  // Only used in SysV
  assert(0);
}

static int _fdpasser_connect(char *path) {
  // Only used in SysV
  assert(0);
}

#endif



#ifdef FDPASSER_SYSV


#include <unistd.h>
#include <stropts.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>


static int send_fd(int passer_fd, int fd_to_send) {
  int rv;
  char buf[1];

  buf[0] = '\0';

  rv = write(passer_fd, buf, 1);
  if (rv != 1) return -1;

  rv = ioctl(passer_fd, I_SENDFD, fd_to_send);
  if (rv != 0) return -1;

  return 1;
}

static int recv_fd(int passer_fd) {
  int flag, rv;
  struct strbuf dat;
  struct strrecvfd recvfd;
  char buf[1024];

  dat.buf = buf;
  dat.maxlen = sizeof(buf);
  flag = 0;

  rv = getmsg(passer_fd, NULL, &dat, &flag);
  if (rv < 0 || dat.len == 0) return -1;

  rv = ioctl(passer_fd, I_RECVFD, &recvfd);
  if (rv != 0) return -1;

  return recvfd.fd;
}


static int fdpasser_mode() {
  return 2;
}


/* FIXME: double-check these functions for descriptor leaks */

static int _fdpasser_server(char *path) {
  int fds[2];
  int filefd;
  int rv;
  int backup_errno;
  unlink(path);

  filefd = creat(path, S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH);
  if (filefd < 0) {
    return -1;
  }
  close(filefd);

  rv = pipe(fds);
  if (rv < 0) return -1;

  rv = ioctl(fds[1], I_PUSH, "connld");
  if (rv != 0) {
    backup_errno = errno;
    close(fds[0]);
    close(fds[1]);
    errno = backup_errno;
    return -1;
  }

  rv = fattach(fds[1], path);
  if (rv < 0) {
    backup_errno = errno;
    close(fds[0]);
    close(fds[1]);
    errno = backup_errno;
    return -1; 
  }

  return fds[0];
}

static int _fdpasser_accept(char fd) {
  struct strrecvfd recvfd;
  int rv;

  rv = ioctl(fd, I_RECVFD, &recvfd);
  if (rv != 0) {
    return -1;
  }

  return recvfd.fd;
}

static int _fdpasser_connect(char *path) {
  int fd;
  int rv;

  fd = open(path, O_RDWR);
  if (fd < 0) {
    return -1;
  }

  rv = isastream(fd);
  if (rv != 1) return -2;

  return fd;
}

#endif




#line 269 "FDpasser.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 413 "FDpasser.c"

XS_EUPXS(XS_AnyEvent__FDpasser_send_fd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AnyEvent__FDpasser_send_fd)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "passer_fd, fd_to_send");
    {
	int	passer_fd = (int)SvIV(ST(0))
;
	int	fd_to_send = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = send_fd(passer_fd, fd_to_send);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_AnyEvent__FDpasser_recv_fd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AnyEvent__FDpasser_recv_fd)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "passer_fd");
    {
	int	passer_fd = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = recv_fd(passer_fd);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_AnyEvent__FDpasser_fdpasser_mode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AnyEvent__FDpasser_fdpasser_mode)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = fdpasser_mode();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_AnyEvent__FDpasser__fdpasser_server); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AnyEvent__FDpasser__fdpasser_server)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "path");
    {
	char *	path = (char *)SvPV_nolen(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = _fdpasser_server(path);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_AnyEvent__FDpasser__fdpasser_accept); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AnyEvent__FDpasser__fdpasser_accept)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = _fdpasser_accept(fd);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_AnyEvent__FDpasser__fdpasser_connect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AnyEvent__FDpasser__fdpasser_connect)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "path");
    {
	char *	path = (char *)SvPV_nolen(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = _fdpasser_connect(path);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_AnyEvent__FDpasser); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_AnyEvent__FDpasser)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("AnyEvent::FDpasser::send_fd", XS_AnyEvent__FDpasser_send_fd, file, "$$");
        (void)newXSproto_portable("AnyEvent::FDpasser::recv_fd", XS_AnyEvent__FDpasser_recv_fd, file, "$");
        (void)newXSproto_portable("AnyEvent::FDpasser::fdpasser_mode", XS_AnyEvent__FDpasser_fdpasser_mode, file, "");
        (void)newXSproto_portable("AnyEvent::FDpasser::_fdpasser_server", XS_AnyEvent__FDpasser__fdpasser_server, file, "$");
        (void)newXSproto_portable("AnyEvent::FDpasser::_fdpasser_accept", XS_AnyEvent__FDpasser__fdpasser_accept, file, "$");
        (void)newXSproto_portable("AnyEvent::FDpasser::_fdpasser_connect", XS_AnyEvent__FDpasser__fdpasser_connect, file, "$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
